Attribute VB_Name = "ScrBuf"
Public ScrArr() As Integer
Public Arr() As Integer

Public Sub ScrBufInit()
      ' Redimming should resize the array AND clear it
      ' (Only this'll clear it in ULTRA quick time compared to a loop!!!)
      ReDim ScrArr(GetSystemMetrics(SM_CXSCREEN) - Form1.Frame1.Width, GetSystemMetrics(SM_CYSCREEN))
End Sub

Public Sub ScrBufPut(X As Integer, Y As Integer, Value As Integer)
      On Error Resume Next
      ScrArr(X, Y) = Value
End Sub

Public Function ScrBufGet(X As Integer, Y As Integer) As Integer
      On Error Resume Next
      ScrBufGet = ScrArr(X, Y)
End Function

Public Sub ScrBufDraw()
      ' Make new array 1/2 the size of the current array (And clear it some...)
      ReDim Arr(UBound(ScrArr, 1) / 2, UBound(ScrArr, 2) / 2)
      
      ' Draw box around the map
      ' Top line: top left to top right
      OutPutfrm.Line (((GetSystemMetrics(SM_CXSCREEN) / 2) - (UBound(Arr, 1) / 2)), ((GetSystemMetrics(SM_CYSCREEN) / 2) - (UBound(Arr, 2) / 2)))-(((GetSystemMetrics(SM_CXSCREEN) / 2) + (UBound(Arr, 1) / 2)), ((GetSystemMetrics(SM_CYSCREEN) / 2) - (UBound(Arr, 2) / 2))), RGB(255, 180, 0)
      ' Bottom line: bottom left to bottom right
      OutPutfrm.Line (((GetSystemMetrics(SM_CXSCREEN) / 2) - (UBound(Arr, 1) / 2)), ((GetSystemMetrics(SM_CYSCREEN) / 2) + (UBound(Arr, 2) / 2)))-(((GetSystemMetrics(SM_CXSCREEN) / 2) + (UBound(Arr, 1) / 2)), ((GetSystemMetrics(SM_CYSCREEN) / 2) + (UBound(Arr, 2) / 2))), RGB(255, 180, 0)
      ' Left line: top left to bottom left
      OutPutfrm.Line (((GetSystemMetrics(SM_CXSCREEN) / 2) - (UBound(Arr, 1) / 2)), ((GetSystemMetrics(SM_CYSCREEN) / 2) - (UBound(Arr, 2) / 2)))-(((GetSystemMetrics(SM_CXSCREEN) / 2) - (UBound(Arr, 1) / 2)), ((GetSystemMetrics(SM_CYSCREEN) / 2) + (UBound(Arr, 2) / 2))), RGB(255, 180, 0)
      ' Right line: top right to bottom right
      OutPutfrm.Line (((GetSystemMetrics(SM_CXSCREEN) / 2) + (UBound(Arr, 1) / 2)), ((GetSystemMetrics(SM_CYSCREEN) / 2) - (UBound(Arr, 2) / 2)))-(((GetSystemMetrics(SM_CXSCREEN) / 2) + (UBound(Arr, 1) / 2)), ((GetSystemMetrics(SM_CYSCREEN) / 2) + (UBound(Arr, 2) / 2))), RGB(255, 180, 0)
      
      ' Set data
      For X = 0 To UBound(ScrArr, 1) Step 2
            For Y = 0 To UBound(ScrArr, 2) Step 2
                  Arr(X / 2, Y / 2) = ScrArr(X, Y)
            Next Y
      Next X
      
      ' Draw onto output form in the center
      For X2 = 0 To UBound(Arr, 1)
            For Y2 = 0 To UBound(Arr, 2)
                  If Arr(X2, Y2) = 1 Then
                        SetPixel OutPutfrm.hDC, ((GetSystemMetrics(SM_CXSCREEN) / 2) - (UBound(Arr, 1) / 2)) + X2, ((GetSystemMetrics(SM_CYSCREEN) / 2) - (UBound(Arr, 2) / 2)) + Y2, RGB(255, 0, 0)
                  ElseIf Arr(X2, Y2) = 2 Then
                        SetPixel OutPutfrm.hDC, ((GetSystemMetrics(SM_CXSCREEN) / 2) - (UBound(Arr, 1) / 2)) + X2, ((GetSystemMetrics(SM_CYSCREEN) / 2) - (UBound(Arr, 2) / 2)) + Y2, RGB(0, 0, 255)
                  End If
            Next Y2
      Next X2
End Sub
